#!/bin/sh
# Script for store system configuration files and information about installed
# packages.
# Скрипт для сохранения списк всех файлов в системе, списка установленных пакетов
# и файлов конфигурации.
#
# http://www.opennet.ru/dev/fsbackup/
# Copyright (c) 2001 by Maxim Chirkov. <mc@tyumen.ru>


PATH=/sbin:/usr/sbin:/usr/local/sbin:/bin:/usr/bin:/usr/local/bin

if [ -r /etc/fsbackup/sysbackup.conf ]; then
        . /etc/fsbackup/sysbackup.conf
else
        echo "Config file not found, exiting"
        exit 1
fi
############################################################################
sysname="`uname | tr '[A-Z]' '[a-z]'`"
echo "OS: $sysname"

# echo "Creating ls-lR..."
# ls -lR / |gzip > $sysbackup_path/${backup_name}-ls-lR.gz

if [ "_$sysname" = "_linux" ]; then
    echo "Creating system config archive..."
    rm -f $sysbackup_path/${backup_name}-rpm_conf.tar
    for cur_conf in `rpm -q -a -c`; do
	tar -rf $sysbackup_path/${backup_name}-rpm_conf.tar $cur_conf 2>/dev/null
    done
    echo "Creating package list..."
    gzip -f $sysbackup_path/${backup_name}-rpm_conf.tar
    rpm -q -a > $sysbackup_path/${backup_name}-rpm.list
    #dpkg -l > $sysbackup_path/${backup_name}-deb.list
    cat /proc/partitions > $sysbackup_path/partitions.txt
    cat /proc/mounts > $sysbackup_path/mounts.txt
    cat /proc/modules > $sysbackup_path/modules.txt
    /sbin/fdisk -l > $sysbackup_path/fdisk.txt
    netstat -rn > $sysbackup_path/routes.txt
    # Бэкап MBR
    #dd if=/dev/sda of=$sysbackup_path/mbr_sda.bin bs=1 count=512
    # Списки устройств.
    #cat /proc/pci > $sysbackup_path/pci.txt
    #cat /proc/bus/usb/devices > $sysbackup_path/usb.txt
    #cat /proc/scsi/scsi > $sysbackup_path/scsi.txt
    
fi
